Simple Two-Way Active Measurement Protocol (STAMP) Extensions for Reflecting STAMP Packet Headers
Internet-Draft draft-ietf-ippm-stamp-ext-hdr-01
Rakesh Gandhi, Ed.
Cisco Systems, Inc.
Canada
rgandhi@cisco.com
Tianran Zhou
Huawei
China
zhoutianran@huawei.com
Zhenqiang Li
China Mobile
China
li_zhenqiang@hotmail.com
14 October 2024
IPPM Working Group
The Simple Two-Way Active Measurement Protocol (STAMP) and its optional extensions can be used for Edge-To-Edge (E2E) active measurement. In Situ Operations, Administration, and Maintenance (IOAM) data fields can be used for recording and collecting Hop-By-Hop (HBH) and E2E operational and telemetry information. This document extends STAMP to reflect IP headers, IPv6 extension headers, and MPLS Network Action Sub-Stacks for HBH and E2E active measurements, for example, using IOAM data fields.

Introduction
The Simple Two-Way Active Measurement Protocol (STAMP) provides capabilities for the measurement of various performance metrics in IP networks [RFC8762] without the use of a control channel to pre-signal session parameters. [RFC8972] defines optional extensions, in the form of TLVs, for STAMP. The STAMP test packets are transmitted along a path between a Session-Sender and a Session-Reflector to measure Edge-To-Edge (E2E) performance delay and packet loss along that path.
In Situ Operations, Administration, and Maintenance (IOAM) is used for recording and collecting operational and telemetry information while the packet traverses a path between two points in the network. The IOAM data fields are defined in [RFC9197]. Currently, there is no adopted method defined to reflect the collected IOAM data fields back to the Sender where the Sender can use that information to support the hop-by-hop and edge-to-edge measurement use cases.
IPv6 packets may carry IPv6 extension headers containing IPv6 options headers for Hop-By-Hop (HBH) and Destination Types as defined in [RFC8200]. [RFC9486] defines option types for HBH and destination options headers to carry IOAM data fields [RFC9197] for the IPv6 data plane.
MPLS packets may carry MPLS Network Action (MNA) Sub-Stacks as defined in [I-D.ietf-mpls-mna-hdr] based on the MNA framework defined in [I-D.ietf-mpls-mna-fwk].
It may be desired to record and collect HBH and E2E operational and telemetry information using active measurement packets between two nodes in a network. This is achieved by augmenting STAMP [RFC8762] by using optional STAMP extensions defined in [RFC8972] to reflect IP headers, IPv6 extension headers, and MNA Sub-Stacks as specified in this document. The procedure defined in this document leverages the existing implementations on the midpoint nodes with IPv6 and MPLS data planes without any additional requirements.

Conventions Used in This Document

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Abbreviations
ECMP: Equal Cost Multi-Path
E2E: Edge-To-Edge
HBH: Hop-By-Hop
IOAM: In Situ Operations, Administration, and Maintenance
MNA: Multiprotocol Label Switching Network Action
MTU: Maximum Transmission Unit
STAMP: Simple Two-way Active Measurement Protocol
TLV: Type-Length-Value

STAMP Reference Topology
In the "STAMP Reference Topology" shown in Figure 1, the STAMP Session-Sender S1 initiates a Session-Sender test packet and the STAMP Session-Reflector R1 transmits a reply Session-Reflector test packet. Node M1 is a midpoint node that does not perform any STAMP processing.
T1 is a transmit timestamp, and T4 is a receive timestamp added by node S1. T2 is a receive timestamp, and T3 is a transmit timestamp added by node R1.
STAMP Reference Topology

          T1                                       T2
         /                                           \
+-------+    Test Packet  +-------+                   +-------+
|       | - - - - - - - - |       | - - - - - - - - ->|       |
|   S1  |=================|   M1  |===================|   R1  |
|       |<- - - - - - - - |       | - - - - - - - - - |       |
+-------+                 +-------+ Reply Test Packet +-------+
         \                                           /
          T4                                       T3

STAMP Session-Sender                     STAMP Session-Reflector

Overview
[RFC8972] defines optional extensions for STAMP. The optional extensions are added in the base STAMP test packet defined in [RFC8762] in the form of TLVs. As specified in [RFC8972], both Session-Sender and Session-Reflector test packets are symmetric in size when including all optional TLVs. The Session-Reflector reflects all received STAMP TLVs from the Session-Sender test packets.
As specified in [RFC8762], STAMP test packets are transmitted with IP/UDP headers. As midpoint nodes do not process the UDP headers in the packets, midpoint nodes are agnostic to the STAMP test packets in the payload.

IPv6 Data Plane
This document defines a new TLV option for STAMP, called "Reflected IPv6 Extension Header Data" (value TBA1). When a STAMP Session-Sender adds an IPv6 extension header such as an IPv6 Hop-By-Hop options header or a Destination options header in the IPv6 header [RFC8200], it also adds a "Reflected IPv6 Extension Header Data" STAMP TLV in the Session-Sender test packet with the length set to the IPv6 extension header (including IPv6 extension header bytes and value field) length and the value field in the TLV initialized to zeros, in order to receive a copy of that IPv6 extension header back in the STAMP TLV. When adding multiple IPv6 extension headers in the Session-Sender test packet, multiple corresponding "Reflected IPv6 Extension Header Data" TLVs are added, each one with the matching length to the IPv6 extension header and in the same order.
An example STAMP test packet for the IPv6 data plane carrying the IPv6 header and IPv6 extension headers and reflected IPv6 header data in STAMP TLVs is shown in Figure 2.
Examples of IPv6 extension headers are: IOAM data fields IPv6 options header defined in [RFC9486], Performance and Diagnostic Metrics (PDM) IPv6 options header defined in [RFC8250], Maximum Path MTU IPv6 options header defined in [RFC9268], Alternate Marking Method IPv6 options header defined in [RFC9343], Routing Header for IPv6 including Segment Routing Header defined in [RFC8754], and any new IPv6 extension header that is defined in the future.
As the procedure defined in this document leverages the existing implementations on the midpoint nodes for the IPv6 extension headers, no additional requirements are specified when carrying these IPv6 extension headers in STAMP. The IPv6 extension header is processed by the nodes using the same procedures specified in the document that defined the IPv6 extension header.
Example STAMP Test Packet with Reflected IPv6 Extension Header Data STAMP TLV

    +--------------------------------------------------------+
    | IPv6 Header                                            |
    +--------------------------------------------------------+
    | IPv6 Extension Header-1 RFC 8200                       |
    +--------------------------------------------------------+
    ~ ...                                                    ~
    +--------------------------------------------------------+
    | IPv6 Extension Header-N RFC 8200                       |
    +--------------------------------------------------------+
    | UDP Header                                             |
    +--------------------------------------------------------+
    | STAMP Packet RFC 8972                                  |
    +--------------------------------------------------------+
    | Reflected IPv6 Extension Header-1 Data STAMP TLV (TBA1)|
    +--------------------------------------------------------+
    ~ ...                                                    ~
    +--------------------------------------------------------+
    | Reflected IPv6 Extension Header-M Data STAMP TLV (TBA1)|
    +--------------------------------------------------------+

When the Session-Reflector receives a STAMP test packet with an IPv6 extension header and a STAMP TLV of "Reflected IPv6 Extension Header Data," the Session-Reflector that supports this STAMP TLV MUST copy the entire IPv6 extension header, including the option type header, into the STAMP "Reflected IPv6 Extension Header Data" TLV in the Session-Reflector payload. When there are multiple IPv6 extension headers in the received Session-Sender test packet, all IPv6 extension headers MUST be copied into the STAMP "Reflected IPv6 Extension Header Data" TLVs in the reply Session-Reflector test packet in the same order.
The Session-Reflector adds the matching IPv6 option in the IPv6 header of the Session-Reflector test packets for the reverse direction.
When the Session-Reflector receives a STAMP test packet with an IPv6 extension header but without a "Reflected IPv6 Extension Header Data" STAMP TLV, the Session-Reflector does not copy the IPv6 extension header into the reply Session-Reflector test packet.
When the Session-Sender test packets carry an IPv6 extension header with an option-type that it does not require the Session-Reflector to reflect in the Session-Reflector test packet, it does not add the matching "Reflected IPv6 Extension Header Data" TLV in the Session-Sender test packet.
If the Session-Reflector receives Session-Sender test packets with non-zero values in the first 4 bytes in the "Reflected IPv6 Extension Header Data" STAMP TLV, it MUST match the values in the corresponding IPv6 extension header before copying data into the STAMP TLV. This mechanism is employed in case of ambiguity when there are multiple IPv6 extension headers with the same length and not all need to be copied and reflected in the STAMP TLV.
The Session-Sender and Session-Reflector test packets are symmetric in size, and hence the Session-Sender and Session-Reflector MUST ensure that the resulting test packets do not exceed the IPv6 MTU after adding the Reflected Data STAMP TLVs. If necessary, Reflected Data STAMP TLVs can be removed to avoid violating the IPv6 MTU limit.
If, for any reason, the Session-Reflector does not use the received Reflected IPv6 Extension Header Data STAMP TLV for reflecting data, it MUST return the STAMP TLV as malformed, i.e., with the M flag set in the STAMP TLV Flags using the procedure defined in [RFC8972].
Note that the use case where the IPv6 extension header length changes in the Session-Sender test packets along the path is outside the scope of this document. Also, the use case where IPv6 extension headers are added or removed in the Session-Sender test packets along the path is outside the scope of this document.

MPLS Data Plane
This document also defines a new TLV option for STAMP, called "Reflected MNA Sub-Stack Data" (value TBA2). When a STAMP Session-Sender adds an MNA Sub-Stack in the test packet, it also adds a "Reflected MNA Sub-Stack Data" STAMP TLV in the Session-Sender test packet with the length set to the MNA Sub-Stack length (NASL) (including In-Stack Ancillary Data (ISD) and Post-Stack Ancillary Data (PSD) and MNA label LSE) and the value field in the TLV initialized to zeros, in order to receive a copy of that MNA Sub-Stack back in the STAMP TLV. When adding multiple MNA Sub-Stacks in the Session-Sender test packet, multiple "Reflected MNA Sub-Stack Data" TLVs MUST be added, each one with the matching length to the MNA Sub-Stack and Ancillary Data and in the same order.
As the procedure defined in this document leverages the existing implementations on the midpoint nodes for the MNA Sub-Stacks, no additional requirements are specified when carrying MNA Sub-Stacks in STAMP. The MNA Sub-Stack is processed by the nodes using the same procedures specified in the document that defined the MNA Sub-Stack.
An example STAMP test packet for the MPLS data plane carrying MNA Sub-Stacks in the MPLS header and reflected MNA Sub-Stack data in STAMP TLVs is shown in Figure 3.
Example STAMP Test Packet with Reflected MNA Sub-Stack Data STAMP TLV

    +------------------------------------------------+
    | MPLS Header                                    |
    +------------------------------------------------+
    | MNA Sub-Stack-1 I-D.ietf-mpls-mna-hdr          |
    +------------------------------------------------+
    ~ ...                                            ~
    +------------------------------------------------+
    | MNA Sub-Stack-N I-D.ietf-mpls-mna-hdr          |
    +------------------------------------------------+
    | IP Header                                      |
    +------------------------------------------------+
    | UDP Header                                     |
    +------------------------------------------------+
    | STAMP Packet RFC 8972                          |
    +------------------------------------------------+
    | Reflected MNA Sub-Stack-1 Data STAMP TLV (TBA2)|
    +------------------------------------------------+
    ~ ...                                            ~
    +------------------------------------------------+
    | Reflected MNA Sub-Stack-M Data STAMP TLV (TBA2)|
    +------------------------------------------------+

When the Session-Reflector receives a STAMP test packet with an MNA and a STAMP TLV of "Reflected MNA Sub-Stack Data," the Session-Reflector that supports this STAMP TLV MUST copy the entire MNA Sub-Stack, including the Ancillary Data and header, into the "Reflected MNA Sub-Stack Data" TLV in the Session-Reflector payload. When there are multiple MNA Sub-Stacks in the Session-Sender test packet, all MNA Sub-Stacks, including Ancillary Data, MUST be copied in the STAMP TLVs and MUST add all MNA Sub-Stacks, including Ancillary Data, in the Session-Reflector test packet in the same order.
The Session-Reflector adds the matching MNA Sub-Stacks and Ancillary Data in the MPLS header of the Session-Reflector test packet for the reverse direction.
When the Session-Reflector receives a STAMP test packet with an MNA Sub-Stack but without a "Reflected MNA Sub-Stack Data" STAMP TLV, the Session-Reflector does not copy the MNA Sub-Stack into the Session-Reflector test packet.
When the Session-Sender test packets carry an MNA Sub-Stack that it does not require the Session-Reflector to reflect in the Session-Reflector test packet, it does not add the matching Reflected MNA Sub-Stack Data TLV in the Session-Sender test packet.
If the Session-Reflector receives Session-Sender test packets with non-zero values in the first 8 bytes (excluding the Ancillary Data field that may change) in the "Reflected MNA Sub-Stack Data" STAMP TLV, it MUST match the values in the corresponding MNA Sub-Stack in the MPLS header before copying data into the STAMP TLV. This mechanism is employed in case of ambiguity when there are multiple MNA Sub-Stacks in the MPLS header with the same length and not all need to be copied and reflected in the STAMP TLV.
If, for any reason, the Session-Reflector does not use the received Reflected MNA Sub-Stack Data STAMP TLV for reflecting data, it MUST return the STAMP TLV as malformed, i.e., with the M flag set in the STAMP TLV Flags using the procedure defined in [RFC8972].
Note that the use case where the MNA Sub-Stack length changes in the Session-Sender test packets along the path is outside the scope of this document. Also, the use case where MNA Sub-Stacks are added or removed in the Session-Sender test packets along the path is outside the scope of this document.

Fixed Header
This document defines a new TLV option for STAMP, called "Reflected Fixed Header Data" (value TBA3). The STAMP TLV can be used to reflect any fixed size header received in the Session-Sender test packet, including IPv4 and IPv6 headers. When a STAMP Session-Sender adds an IP header, it also adds a "Reflected Fixed Header Data" STAMP TLV in the Session-Sender test packet with the length set to the IP header length and the value field in the TLV initialized to zeros, in order to receive a copy of that IP header back in the STAMP TLV. When adding multiple IP headers in the Session-Sender test packet, multiple corresponding "Reflected Fixed Header Data" TLVs are added, each one with the matching length to the IP header and in the same order.
An example STAMP test packet carrying the IP header and reflected IP header in STAMP TLVs is shown in Figure 4.
Example STAMP Test Packet with Reflected Fixed Header Data STAMP TLV

    +----------------------------------------------+
    | IP Header                                    |
    +----------------------------------------------+
    | UDP Header                                   |
    +----------------------------------------------+
    | STAMP Packet RFC 8972                        |
    +----------------------------------------------+
    | Reflected Fixed Header Data STAMP TLV(TBA3)  |
    +----------------------------------------------+

When the Session-Reflector receives a STAMP test packet with a STAMP TLV of "Reflected Fixed Header Data," the Session-Reflector that supports this STAMP TLV MUST copy the IP header into the "Reflected Fixed Header Data" TLV in the Session-Reflector payload. When there are multiple IP headers in the received Session-Sender test packet, all IP headers MUST be copied into the "Reflected Fixed Header Data" TLVs in the reply Session-Reflector test packet in the same order.
When the Session-Reflector receives a STAMP test packet with an IP header but without a "Reflected Fixed Header Data" STAMP TLV, the Session-Reflector does not copy the IP header into the reply Session-Reflector test packet.
When the Session-Sender test packets carry an IP header that it does not require the Session-Reflector to reflect in the Session-Reflector test packet, it does not add the matching "Reflected Fixed Header Data" TLV in the Session-Sender test packet.
If the Session-Reflector receives Session-Sender test packets with non-zero values in the first 4 bytes in the "Reflected Fixed Header Data" STAMP TLV, it MUST match the values in the corresponding IP header before copying data into the STAMP TLV. This mechanism is employed in case of ambiguity when there are multiple IP headers with the same length and not all need to be copied and reflected in the STAMP TLV.
The Session-Sender and Session-Reflector test packets are symmetric in size, and hence the Session-Sender and Session-Reflector MUST ensure that the resulting test packets do not exceed the IP MTU after adding the Reflected Data STAMP TLVs. If necessary, Reflected Data STAMP TLVs can be removed to avoid violating the IP MTU limit.
If, for any reason, the Session-Reflector does not use the received "Reflected Fixed Header Data" STAMP TLV for reflecting data, it MUST return the STAMP TLV as malformed, i.e., with the M flag set in the STAMP TLV Flags using the procedure defined in [RFC8972].

Use Case of Reflecting IOAM Data Fields
In Situ Operations, Administration, and Maintenance (IOAM) is used for recording and collecting operational and telemetry information while the packet traverses a path between two points in the network. The IOAM data fields are defined in [RFC9197]. Examples of data recorded by IOAM Trace Options include per-hop information, such as node ID, timestamp, queue depth, interface ID, interface load, etc. The information collected can be used for monitoring ECMP paths, proof-of-transit, and troubleshooting failures in the network. The procedure and STAMP extensions defined in this document can be used to reflect the collected IOAM data fields back to the Sender, where the Sender can use that information to support the hop-by-hop and edge-to-edge measurement use cases.

Use Case of IOAM for IPv6 Data Plane
[RFC9486] defines types for HBH and destination options headers and is used to carry the IOAM option types defined in [RFC9197] for the IPv6 data plane. The STAMP Session-Sender and Session-Reflector test packets carry the IPv6 options headers with IOAM option types for recording and collecting HBH and E2E operational and telemetry information for active measurement, as shown in Figure 5. The Session-Sender, midpoints, and Session-Reflector nodes process the IOAM data fields as defined in [RFC9486]. Note that using the IOAM option type "Incremental Trace Option-Type" is not supported by [RFC9486].
Example STAMP Test Packet with Reflected IPv6 Extension Header Data TLV

    +------------------------------------------------------+
    | IPv6 Header                                          |
    +------------------------------------------------------+
    | HBH IOAM IPv6 Options Header RFC 9486                |
    +------------------------------------------------------+
    | UDP Header                                           |
    +------------------------------------------------------+
    | STAMP Packet RFC 8972                                |
    +------------------------------------------------------+
    | Reflected IPv6 Extension Header Data STAMP TLV (TBA1)|
    +------------------------------------------------------+

Use Case of IOAM for MPLS Data Plane
[I-D.ietf-mpls-mna-hdr] defines the MNA Sub-Stack to carry various Network Actions with Ancillary data. [I-D.gandhi-mpls-mna-ioam-dex] defines extensions using MNA to carry various IOAM data fields as Post-Stack Data (PSD) for the MPLS data plane. The STAMP Session-Sender and Session-Reflector test packets carry the MNA Sub-Stack for recording and collecting HBH and E2E operational and telemetry information for active measurement, as shown in Figure 6.
Example STAMP Test Packet with Reflected MNA Sub-Stack Data TLV

    +-------------------------------------------------+
    | MPLS Header                                     |
    +-------------------------------------------------+
    | HBH IOAM MNA Sub-Stack RFC 9197                 |
    +-------------------------------------------------+
    | IP Header                                       |
    +-------------------------------------------------+
    | UDP Header                                      |
    +-------------------------------------------------+
    | STAMP Packet RFC 8972                           |
    +-------------------------------------------------+
    | Reflected MNA Sub-Stack Data STAMP TLV (TBA2)   |
    +-------------------------------------------------+

STAMP Extensions

Reflected IPv6 Extension Header Data STAMP TLV
The "Reflected IPv6 Extension Header Data" STAMP TLV is carried by Session-Sender and Session-Reflector test packets. STAMP test packets may carry multiple TLVs of this type. The same Reflected IPv6 Extension Header Data STAMP TLV Type is used for reflecting various IPv6 extension headers, including HBH and Destination IPv6 options headers. The format of the Reflected IPv6 Extension Header Data TLV is shown in Figure 7.
Reflected IPv6 Extension Header Data STAMP TLV

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |STAMP TLV Flags|  Type=TBA1    |         Length                |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                  Reflected IPv6 Extension Header Data         |
 ~                                                               ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The TLV fields are defined as follows:
Type: Type (value TBA1)
STAMP TLV Flags: The STAMP TLV Flags follow the procedures described in [RFC8972].
Length: A two-octet field equal to the length of the Data in octets.
The Session-Reflector MUST return an error in the STAMP TLV Flags when it determines that the length of the TLV does not match the length of the corresponding IPv6 extension header in the IPv6 header.

Reflected MNA Sub-Stack Data STAMP TLV
The "Reflected MNA Sub-Stack Data" STAMP TLV is carried by Session-Sender and Session-Reflector test packets. STAMP test packets may carry multiple TLVs of this type. The format of the Reflected MNA Sub-Stack Data TLV is shown in Figure 8.
Reflected MNA Sub-Stack Data STAMP TLV

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |STAMP TLV Flags|  Type=TBA2    |         Length                |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                  Reflected MNA Sub-Stack Data                 |
 ~                                                               ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The TLV fields are defined as follows:
Type: Type (value TBA2)
STAMP TLV Flags: The STAMP TLV Flags follow the procedures described in [RFC8972].
Length: A two-octet field equal to the length of the Data in octets.
The Session-Reflector MUST return an error in the STAMP TLV Flags when it determines that the length of the TLV does not match the length of the corresponding MNA Sub-Stack when processing in the same order as the MNA Sub-Stacks in the MPLS header.

Reflected Fixed Header Data STAMP TLV
The "Reflected Fixed Header Data" STAMP TLV is carried by Session-Sender and Session-Reflector test packets. STAMP test packets may carry multiple TLVs of this type. The format of the "Reflected Fixed Header Data" TLV is shown in Figure 9.
Reflected Fixed Header Data STAMP TLV

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |STAMP TLV Flags|  Type=TBA3    |         Length                |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                  Reflected Fixed Header Data                  |
 ~                                                               ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The TLV fields are defined as follows:
Type: Type (value TBA3)
STAMP TLV Flags: The STAMP TLV Flags follow the procedures described in [RFC8972].
Length: A two-octet field equal to the length of the Data in octets. For an IPv4 header, the length is set to 20, and for an IPv6 header, the length is set to 60.
The Session-Reflector MUST return an error in the STAMP TLV Flags when it determines that the length of the TLV does not match the length of the corresponding IP header when processing in the same order.

One-Way Measurement Using Reflected Data STAMP TLVs
In the case of one-way HBH and E2E measurements, the Session-Reflector does not need to add IPv6 extension headers and MNA Sub-Stacks in the reply Session-Reflector test packets matching the received IPv6 extension headers and MNA Sub-Stacks, respectively.
In this document, the Sub-TLV "Extension Header Control" (Type TBA4) is defined for the STAMP TLV Type "Reflected Test Packet Control TLV" (Type TBA-ASYM) introduced in [I-D.ietf-ippm-asymmetrical-pkts].
When a Session-Sender test packet is received with the "Extension Header Control" Sub-TLV, the Session-Reflector does not add the received IPv6 extension headers in the IPv6 header and MNA Sub-Stacks in the MPLS header of the reply Session-Reflector STAMP test packet.
In the absence of this Sub-TLV in the received Session-Sender test packet, the Session-Reflector inserts new IPv6 extension headers matching all received IPv6 extension headers (except the routing extension headers specific to the Session-Sender test packets) in the IPv6 header of the reply Session-Reflector test packet. Similarly, the Session-Reflector inserts new MNA Sub-Stacks matching all received MNA Sub-Stacks in the MPLS header of the reply Session-Reflector test packet.
The IP headers, IPv6 extension headers, and MNA Sub-Stacks received in the Session-Sender test packets are still reflected in STAMP TLVs to the Session-Sender.

Security Considerations
The security considerations specified in [RFC8762], [RFC8972], [RFC8200], and [I-D.ietf-mpls-mna-hdr] apply to the procedure and extensions defined in this document. In addition, the security considerations specified in [RFC9197] also apply when using the IPv6 options headers defined in that document.

IANA Considerations
IANA has created the "STAMP TLV Types" registry for [RFC8972]. IANA is requested to allocate a value for the "Reflected IPv6 Extension Header Data" TLV Type, a value for the "Reflected MNA Sub-Stack Data" TLV Type, and "Reflected Fixed Header Data" TLV Type from the IETF Review TLV range of the same registry.
STAMP TLV Types
Value | Description | Reference
TBA1 | Reflected IPv6 Extension Header Data | This document
TBA2 | Reflected MNA Sub-Stack Data | This document
TBA3 | Reflected Fixed Header Data | This document
IANA is requested to allocate a value for the Sub-TLV Type "Extension Header Control" (Type TBA4) for the STAMP TLV Type "Reflected Test Packet Control TLV" (Type TBA-ASYM) defined in [I-D.ietf-ippm-asymmetrical-pkts].
Sub-TLV Type for Reflected Test Packet Control STAMP TLV
Value | Description | Reference
TBA4 | Extension Header Control | This document

Normative References

Informative References
[RFC8762]
[RFC8972]
[RFC9197]
[RFC8200]
[RFC9486]
[I-D.ietf-mpls-mna-hdr]
[I-D.ietf-mpls-mna-fwk]
[RFC2119]
[RFC8174]
[RFC8250]
[RFC9268]
[RFC9343]
[RFC8754]
[I-D.gandhi-mpls-mna-ioam-dex]
[I-D.ietf-ippm-asymmetrical-pkts]

Acknowledgments
The authors would like to thank Greg Mirsky, Xiao Min, Tal Mizrahi, Cheng Li, Giuseppe Fioccola, and Jie Dong for reviewing this document and providing useful comments and suggestions.